
#property copyright "Copyright  2011"
#property link      "http://www.metaquotes.net/"

double pip;
extern color TakeProfitColor = Green;
extern color StopLossColor = Red;
extern color PendingOrderColor = Yellow;

int init() {
   pip = Point;
   if (Digits == 3 || Digits == 5) pip = 10.0 * Point;
   ObjectsDeleteAll();
   return (0);
}

int deinit() {
   ObjectsDeleteAll();
   return (0);
}

int start() {

   Comment("Move the lines to modify your stop/profit levels");
   Comment(MarketInfo(Symbol(), MODE_TICKSIZE) + " " + MarketInfo(Symbol(), MODE_POINT));
   for (int l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderType() == OP_BUY) {
            if (ObjectFind(OrderTicket() + "TP") != -1) {
               if (MathAbs(OrderTakeProfit() - ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) > Bid + MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1), 0, Blue);
                  return (0);
               }
               if (OrderTakeProfit() > 0.0) {
                  ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderTakeProfit() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderTakeProfit() > 0.0) {
                  ObjectCreate(OrderTicket() + "TP", OBJ_HLINE, 0, OrderOpenTime(), OrderTakeProfit(), 0, 0);
                  ObjectSet(OrderTicket() + "TP", OBJPROP_COLOR, TakeProfitColor);
                  ObjectCreate(OrderTicket() + "TPLine", OBJ_TEXT, 0, Time[0], OrderTakeProfit(), 0, 0);
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderTakeProfit() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
               }
            }
            if (ObjectFind(OrderTicket() + "SL") != -1) {
               if (MathAbs(OrderStopLoss() - ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) < Bid - MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), OrderOpenPrice(), ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1), OrderTakeProfit(), 0, Blue));
               }
               if (OrderStopLoss() > 0.0) {
                  ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderStopLoss() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", StopLossColor);
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderStopLoss() > 0.0) {
                  ObjectCreate(OrderTicket() + "SL", OBJ_HLINE, 0, OrderOpenTime(), OrderStopLoss(), 0, 0);
                  ObjectSet(OrderTicket() + "SL", OBJPROP_COLOR, StopLossColor);
                  ObjectCreate(OrderTicket() + "SLLine", OBJ_TEXT, 0, Time[0], OrderStopLoss(), 0, 0);
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderStopLoss() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", StopLossColor);
               } else ObjectDelete(OrderTicket() + "SL");
            }
         }
         if (OrderType() == OP_BUYSTOP) {
            if (ObjectFind(OrderTicket() + "TP") != -1) {
               if (MathAbs(OrderTakeProfit() - ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) > OrderOpenPrice() + MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1), 0, Blue);
                  return (0);
               }
               if (OrderTakeProfit() > 0.0) {
                  ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderTakeProfit() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderTakeProfit() > 0.0) {
                  ObjectCreate(OrderTicket() + "TP", OBJ_HLINE, 0, OrderOpenTime(), OrderTakeProfit(), 0, 0);
                  ObjectSet(OrderTicket() + "TP", OBJPROP_COLOR, TakeProfitColor);
                  ObjectCreate(OrderTicket() + "TPLine", OBJ_TEXT, 0, Time[0], OrderTakeProfit(), 0, 0);
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderTakeProfit() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
               } else ObjectDelete(OrderTicket() + "TP");
            }
            if (ObjectFind(OrderTicket() + "SL") != -1) {
               if (MathAbs(OrderStopLoss() - ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) < OrderOpenPrice() - MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), OrderOpenPrice(), ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1), OrderTakeProfit(), 0, Blue));
               }
               if (OrderStopLoss() > 0.0) {
                  ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderStopLoss() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", StopLossColor);
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderStopLoss() > 0.0) {
                  ObjectCreate(OrderTicket() + "SL", OBJ_HLINE, 0, OrderOpenTime(), OrderStopLoss(), 0, 0);
                  ObjectSet(OrderTicket() + "SL", OBJPROP_COLOR, StopLossColor);
                  ObjectCreate(OrderTicket() + "SLLine", OBJ_TEXT, 0, Time[0], OrderStopLoss(), 0, 0);
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderStopLoss() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", StopLossColor);
               } else ObjectDelete(OrderTicket() + "SL");
            }
            if (ObjectFind(OrderTicket() + "OP") != -1) {
               if (MathAbs(OrderOpenPrice() - ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1) > Ask + MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "OP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1), OrderStopLoss(), OrderTakeProfit(), 0, Blue));
               }
               if (OrderOpenPrice() > 0.0) ObjectSet(OrderTicket() + "OP", OBJPROP_PRICE1, OrderOpenPrice());
            } else {
               ObjectCreate(OrderTicket() + "OP", OBJ_HLINE, 0, OrderOpenTime(), OrderOpenPrice(), 0, 0);
               ObjectSet(OrderTicket() + "OP", OBJPROP_COLOR, PendingOrderColor);
            }
         }
         if (OrderType() == OP_BUYLIMIT) {
            if (ObjectFind(OrderTicket() + "TP") != -1) {
               if (MathAbs(OrderTakeProfit() - ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) > OrderOpenPrice() + MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1), 0, Blue);
                  return (0);
               }
               if (OrderTakeProfit() > 0.0) {
                  ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderTakeProfit() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderTakeProfit() > 0.0) {
                  ObjectCreate(OrderTicket() + "TP", OBJ_HLINE, 0, OrderOpenTime(), OrderTakeProfit(), 0, 0);
                  ObjectSet(OrderTicket() + "TP", OBJPROP_COLOR, TakeProfitColor);
                  ObjectCreate(OrderTicket() + "TPLine", OBJ_TEXT, 0, Time[0], OrderTakeProfit(), 0, 0);
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderTakeProfit() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
               } else ObjectDelete(OrderTicket() + "TP");
            }
            if (ObjectFind(OrderTicket() + "SL") != -1) {
               if (MathAbs(OrderStopLoss() - ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) < OrderOpenPrice() - MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), OrderOpenPrice(), ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1), OrderTakeProfit(), 0, Blue));
               }
               if (OrderStopLoss() > 0.0) {
                  ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderStopLoss() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", StopLossColor);
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderStopLoss() > 0.0) {
                  ObjectCreate(OrderTicket() + "SL", OBJ_HLINE, 0, OrderOpenTime(), OrderStopLoss(), 0, 0);
                  ObjectSet(OrderTicket() + "SL", OBJPROP_COLOR, StopLossColor);
                  ObjectCreate(OrderTicket() + "SLLine", OBJ_TEXT, 0, Time[0], OrderStopLoss(), 0, 0);
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderStopLoss() - OrderOpenPrice()) / Point, 0), 9, "Times New Roman", StopLossColor);
               } else ObjectDelete(OrderTicket() + "SL");
            }
            if (ObjectFind(OrderTicket() + "OP") != -1) {
               if (MathAbs(OrderOpenPrice() - ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1) < Ask - MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "OP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1), OrderStopLoss(), OrderTakeProfit(), 0, Blue));
               }
               if (OrderOpenPrice() > 0.0) ObjectSet(OrderTicket() + "OP", OBJPROP_PRICE1, OrderOpenPrice());
            } else {
               ObjectCreate(OrderTicket() + "OP", OBJ_HLINE, 0, OrderOpenTime(), OrderOpenPrice(), 0, 0);
               ObjectSet(OrderTicket() + "OP", OBJPROP_COLOR, PendingOrderColor);
            }
         }
         if (OrderType() == OP_SELL) {
            if (ObjectFind(OrderTicket() + "TP") != -1) {
               if (MathAbs(OrderTakeProfit() - ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) < Ask - MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1), 0, Blue);
                  return (0);
               }
               if (OrderTakeProfit() > 0.0) {
                  ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderOpenPrice() - OrderTakeProfit()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderTakeProfit() > 0.0) {
                  ObjectCreate(OrderTicket() + "TP", OBJ_HLINE, 0, OrderOpenTime(), OrderTakeProfit(), 0, 0);
                  ObjectSet(OrderTicket() + "TP", OBJPROP_COLOR, TakeProfitColor);
                  ObjectCreate(OrderTicket() + "TPLine", OBJ_TEXT, 0, Time[0], OrderTakeProfit(), 0, 0);
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderOpenPrice() - OrderTakeProfit()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
               } else ObjectDelete(OrderTicket() + "TP");
            }
            if (ObjectFind(OrderTicket() + "SL") != -1) {
               if (MathAbs(OrderStopLoss() - ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) > Ask + MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), OrderOpenPrice(), ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1), OrderTakeProfit(), 0, Blue));
               }
               if (OrderStopLoss() > 0.0) {
                  ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderOpenPrice() - OrderStopLoss()) / Point, 0), 9, "Times New Roman", StopLossColor);
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderStopLoss() > 0.0) {
                  ObjectCreate(OrderTicket() + "SL", OBJ_HLINE, 0, OrderOpenTime(), OrderStopLoss(), 0, 0);
                  ObjectSet(OrderTicket() + "SL", OBJPROP_COLOR, StopLossColor);
                  ObjectCreate(OrderTicket() + "SLLine", OBJ_TEXT, 0, Time[0], OrderStopLoss(), 0, 0);
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderOpenPrice() - OrderStopLoss()) / Point, 0), 9, "Times New Roman", StopLossColor);
               } else ObjectDelete(OrderTicket() + "SL");
            }
         }
         if (OrderType() == OP_SELLSTOP) {
            if (ObjectFind(OrderTicket() + "TP") != -1) {
               if (MathAbs(OrderTakeProfit() - ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) < OrderOpenPrice() - MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1), 0, Blue);
                  return (0);
               }
               if (OrderTakeProfit() > 0.0) {
                  ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderOpenPrice() - OrderTakeProfit()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderTakeProfit() > 0.0) {
                  ObjectCreate(OrderTicket() + "TP", OBJ_HLINE, 0, OrderOpenTime(), OrderTakeProfit(), 0, 0);
                  ObjectSet(OrderTicket() + "TP", OBJPROP_COLOR, TakeProfitColor);
                  ObjectCreate(OrderTicket() + "TPLine", OBJ_TEXT, 0, Time[0], OrderTakeProfit(), 0, 0);
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderOpenPrice() - OrderTakeProfit()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
               } else ObjectDelete(OrderTicket() + "TP");
            }
            if (ObjectFind(OrderTicket() + "SL") != -1) {
               if (MathAbs(OrderStopLoss() - ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) > OrderOpenPrice() + MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), OrderOpenPrice(), ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1), OrderTakeProfit(), 0, Blue));
               }
               if (OrderStopLoss() > 0.0) {
                  ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderOpenPrice() - OrderStopLoss()) / Point, 0), 9, "Times New Roman", StopLossColor);
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderStopLoss() > 0.0) {
                  ObjectCreate(OrderTicket() + "SL", OBJ_HLINE, 0, OrderOpenTime(), OrderStopLoss(), 0, 0);
                  ObjectSet(OrderTicket() + "SL", OBJPROP_COLOR, StopLossColor);
                  ObjectCreate(OrderTicket() + "SLLine", OBJ_TEXT, 0, Time[0], OrderStopLoss(), 0, 0);
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderOpenPrice() - OrderStopLoss()) / Point, 0), 9, "Times New Roman", StopLossColor);
               } else ObjectDelete(OrderTicket() + "SL");
            }
            if (ObjectFind(OrderTicket() + "OP") != -1) {
               if (MathAbs(OrderOpenPrice() - ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1) < Bid - MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "OP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1), OrderStopLoss(), OrderTakeProfit(), 0, Blue));
               }
               if (OrderOpenPrice() > 0.0) ObjectSet(OrderTicket() + "OP", OBJPROP_PRICE1, OrderOpenPrice());
            } else {
               ObjectCreate(OrderTicket() + "OP", OBJ_HLINE, 0, OrderOpenTime(), OrderOpenPrice(), 0, 0);
               ObjectSet(OrderTicket() + "OP", OBJPROP_COLOR, PendingOrderColor);
            }
         }
         if (OrderType() == OP_SELLLIMIT) {
            if (ObjectFind(OrderTicket() + "TP") != -1) {
               if (MathAbs(OrderTakeProfit() - ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) < OrderOpenPrice() - MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), ObjectGet(OrderTicket() + "TP", OBJPROP_PRICE1), 0, Blue);
                  return (0);
               }
               if (OrderTakeProfit() > 0.0) {
                  ObjectSet(OrderTicket() + "TP", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderOpenPrice() - OrderTakeProfit()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_PRICE1, OrderTakeProfit());
                  ObjectSet(OrderTicket() + "TPLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderTakeProfit() > 0.0) {
                  ObjectCreate(OrderTicket() + "TP", OBJ_HLINE, 0, OrderOpenTime(), OrderTakeProfit(), 0, 0);
                  ObjectSet(OrderTicket() + "TP", OBJPROP_COLOR, TakeProfitColor);
                  ObjectCreate(OrderTicket() + "TPLine", OBJ_TEXT, 0, Time[0], OrderTakeProfit(), 0, 0);
                  ObjectSetText(OrderTicket() + "TPLine", DoubleToStr((OrderOpenPrice() - OrderTakeProfit()) / Point, 0), 9, "Times New Roman", TakeProfitColor);
               } else ObjectDelete(OrderTicket() + "TP");
            }
            if (ObjectFind(OrderTicket() + "SL") != -1) {
               if (MathAbs(OrderStopLoss() - ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) > OrderOpenPrice() + MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), OrderOpenPrice(), ObjectGet(OrderTicket() + "SL", OBJPROP_PRICE1), OrderTakeProfit(), 0, Blue));
               }
               if (OrderStopLoss() > 0.0) {
                  ObjectSet(OrderTicket() + "SL", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderOpenPrice() - OrderStopLoss()) / Point, 0), 9, "Times New Roman", StopLossColor);
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_PRICE1, OrderStopLoss());
                  ObjectSet(OrderTicket() + "SLLine", OBJPROP_TIME1, Time[0]);
               }
            } else {
               if (OrderStopLoss() > 0.0) {
                  ObjectCreate(OrderTicket() + "SL", OBJ_HLINE, 0, OrderOpenTime(), OrderStopLoss(), 0, 0);
                  ObjectSet(OrderTicket() + "SL", OBJPROP_COLOR, StopLossColor);
                  ObjectCreate(OrderTicket() + "SLLine", OBJ_TEXT, 0, Time[0], OrderStopLoss(), 0, 0);
                  ObjectSetText(OrderTicket() + "SLLine", DoubleToStr((OrderOpenPrice() - OrderStopLoss()) / Point, 0), 9, "Times New Roman", StopLossColor);
               } else ObjectDelete(OrderTicket() + "SL");
            }
            if (ObjectFind(OrderTicket() + "OP") != -1) {
               if (MathAbs(OrderOpenPrice() - ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1)) > pip && ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1) > Bid + MarketInfo(Symbol(), MODE_STOPLEVEL) * Point) {
                  if (MarketInfo(Symbol(), MODE_TICKSIZE) > Point) ObjectSet(OrderTicket() + "OP", OBJPROP_PRICE1, MathRound(ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1) / MarketInfo(Symbol(), MODE_TICKSIZE)) * MarketInfo(Symbol(), MODE_TICKSIZE));
                  return (OrderModify(OrderTicket(), ObjectGet(OrderTicket() + "OP", OBJPROP_PRICE1), OrderStopLoss(), OrderTakeProfit(), 0, Blue));
               }
               if (OrderOpenPrice() > 0.0) ObjectSet(OrderTicket() + "OP", OBJPROP_PRICE1, OrderOpenPrice());
            } else {
               ObjectCreate(OrderTicket() + "OP", OBJ_HLINE, 0, OrderOpenTime(), OrderOpenPrice(), 0, 0);
               ObjectSet(OrderTicket() + "OP", OBJPROP_COLOR, PendingOrderColor);
            }
         }
      }
   }
   for (int l_pos_4 = 0; l_pos_4 < OrdersHistoryTotal(); l_pos_4++) {
      OrderSelect(l_pos_4, SELECT_BY_POS, MODE_HISTORY);
      if (ObjectFind(OrderTicket() + "OP") > -1) ObjectDelete(OrderTicket() + "OP");
      if (ObjectFind(OrderTicket() + "TP") > -1) ObjectDelete(OrderTicket() + "TP");
      if (ObjectFind(OrderTicket() + "SL") > -1) ObjectDelete(OrderTicket() + "SL");
      if (ObjectFind(OrderTicket() + "TPLine") > -1) ObjectDelete(OrderTicket() + "TPLine");
      if (ObjectFind(OrderTicket() + "SLLine") > -1) ObjectDelete(OrderTicket() + "SLLine");
   }
   return (0);
}